# Generated by Django 4.0 on 2023-10-03 07:32

from django.db import migrations, models
import django.db.models.deletion
import simple_history.models
import uuid


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
        ('auth', '0012_alter_user_first_name_max_length'),
    ]

    operations = [
        migrations.CreateModel(
            name='Item',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description_en', models.CharField(blank=True, max_length=100, null=True)),
                ('description_ar', models.CharField(blank=True, max_length=100, null=True)),
                ('unit_price', models.DecimalField(decimal_places=10, max_digits=20)),
                ('quantity', models.IntegerField(default=1)),
                ('vat_amount', models.DecimalField(blank=True, decimal_places=5, max_digits=10, null=True)),
                ('vat_rate', models.DecimalField(blank=True, decimal_places=2, default=0.15, max_digits=10)),
                ('discount', models.DecimalField(blank=True, decimal_places=2, max_digits=10, null=True)),
                ('subtotal_excluding_vat', models.DecimalField(blank=True, decimal_places=10, max_digits=20)),
                ('subtotal_including_vat', models.DecimalField(blank=True, decimal_places=10, max_digits=20)),
                ('product_object_id', models.UUIDField()),
                ('invoice_object_id', models.UUIDField()),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('invoice_content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='einvoices_invoice_content_type', to='contenttypes.contenttype')),
                ('product_content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='einvoices_product_content_type', to='contenttypes.contenttype')),
            ],
            options={
                'db_table': 'takamol_einvoice.items',
            },
        ),
        migrations.CreateModel(
            name='Invoice',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False, unique=True)),
                ('model_name', models.CharField(choices=[('STANDARD', 'Standard'), ('SIMPLIFIED', 'Simplified')], max_length=10)),
                ('parent_id', models.UUIDField(blank=True, db_index=True, null=True)),
                ('note', models.CharField(blank=True, max_length=500, null=True)),
                ('type', models.CharField(choices=[('DEBIT', 'Debit'), ('CREDIT', 'Credit'), ('TAX', 'Tax')], max_length=10)),
                ('tax_number', models.CharField(blank=True, default='300892771510003', max_length=15, null=True)),
                ('serial_number', models.CharField(blank=True, max_length=20, null=True, unique=True)),
                ('seller_name', models.CharField(blank=True, default='شركة تكامل لخدمات الأعمال', max_length=100, null=True)),
                ('total_excluding_vat', models.DecimalField(blank=True, decimal_places=2, max_digits=10, null=True)),
                ('vat_amount', models.DecimalField(blank=True, decimal_places=2, max_digits=10, null=True)),
                ('total_including_vat', models.DecimalField(blank=True, decimal_places=2, max_digits=10, null=True)),
                ('template_name', models.CharField(blank=True, max_length=120, null=True)),
                ('has_warnings', models.BooleanField(blank=True, default=False, null=True)),
                ('encoded_invoice', models.TextField(blank=True, max_length=55000, null=True)),
                ('zatca_status', models.CharField(blank=True, choices=[('REPORTED', 'Reported'), ('NOT_REPORTED', 'Not Reported')], max_length=25, null=True)),
                ('hash_key', models.CharField(blank=True, max_length=250, null=True)),
                ('icv', models.IntegerField(blank=True, db_index=True, null=True)),
                ('qr_code', models.CharField(blank=True, max_length=700, null=True)),
                ('object_id', models.UUIDField()),
                ('actual_delivery_date', models.DateTimeField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.contenttype')),
            ],
            options={
                'db_table': 'takamol_einvoice.invoices',
            },
        ),
        migrations.CreateModel(
            name='HistoricalItem',
            fields=[
                ('id', models.BigIntegerField(auto_created=True, blank=True, db_index=True, verbose_name='ID')),
                ('description_en', models.CharField(blank=True, max_length=100, null=True)),
                ('description_ar', models.CharField(blank=True, max_length=100, null=True)),
                ('unit_price', models.DecimalField(decimal_places=10, max_digits=20)),
                ('quantity', models.IntegerField(default=1)),
                ('vat_amount', models.DecimalField(blank=True, decimal_places=5, max_digits=10, null=True)),
                ('vat_rate', models.DecimalField(blank=True, decimal_places=2, default=0.15, max_digits=10)),
                ('discount', models.DecimalField(blank=True, decimal_places=2, max_digits=10, null=True)),
                ('subtotal_excluding_vat', models.DecimalField(blank=True, decimal_places=10, max_digits=20)),
                ('subtotal_including_vat', models.DecimalField(blank=True, decimal_places=10, max_digits=20)),
                ('product_object_id', models.UUIDField()),
                ('invoice_object_id', models.UUIDField()),
                ('created_at', models.DateTimeField(blank=True, editable=False)),
                ('updated_at', models.DateTimeField(blank=True, editable=False)),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField()),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to='auth.user')),
                ('invoice_content_type', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='contenttypes.contenttype')),
                ('product_content_type', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='contenttypes.contenttype')),
            ],
            options={
                'verbose_name': 'historical item',
                'db_table': 'items_history',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
        migrations.CreateModel(
            name='HistoricalInvoice',
            fields=[
                ('id', models.UUIDField(db_index=True, default=uuid.uuid4, editable=False)),
                ('model_name', models.CharField(choices=[('STANDARD', 'Standard'), ('SIMPLIFIED', 'Simplified')], max_length=10)),
                ('parent_id', models.UUIDField(blank=True, db_index=True, null=True)),
                ('note', models.CharField(blank=True, max_length=500, null=True)),
                ('type', models.CharField(choices=[('DEBIT', 'Debit'), ('CREDIT', 'Credit'), ('TAX', 'Tax')], max_length=10)),
                ('tax_number', models.CharField(blank=True, default='300892771510003', max_length=15, null=True)),
                ('serial_number', models.CharField(blank=True, db_index=True, max_length=20, null=True)),
                ('seller_name', models.CharField(blank=True, default='شركة تكامل لخدمات الأعمال', max_length=100, null=True)),
                ('total_excluding_vat', models.DecimalField(blank=True, decimal_places=2, max_digits=10, null=True)),
                ('vat_amount', models.DecimalField(blank=True, decimal_places=2, max_digits=10, null=True)),
                ('total_including_vat', models.DecimalField(blank=True, decimal_places=2, max_digits=10, null=True)),
                ('template_name', models.CharField(blank=True, max_length=120, null=True)),
                ('has_warnings', models.BooleanField(blank=True, default=False, null=True)),
                ('encoded_invoice', models.TextField(blank=True, max_length=55000, null=True)),
                ('zatca_status', models.CharField(blank=True, choices=[('REPORTED', 'Reported'), ('NOT_REPORTED', 'Not Reported')], max_length=25, null=True)),
                ('hash_key', models.CharField(blank=True, max_length=250, null=True)),
                ('icv', models.IntegerField(blank=True, db_index=True, null=True)),
                ('qr_code', models.CharField(blank=True, max_length=700, null=True)),
                ('object_id', models.UUIDField()),
                ('actual_delivery_date', models.DateTimeField(blank=True, null=True)),
                ('created_at', models.DateTimeField(blank=True, editable=False)),
                ('updated_at', models.DateTimeField(blank=True, editable=False)),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField()),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('content_type', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='contenttypes.contenttype')),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to='auth.user')),
            ],
            options={
                'verbose_name': 'historical invoice',
                'db_table': 'invoice_history',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
    ]
