# Generated by Django 4.0 on 2023-10-03 07:32

from django.db import migrations, models
import django.db.models.deletion
import uuid


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
    ]

    operations = [
        migrations.CreateModel(
            name='ZatcaKey',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('username', models.CharField(blank=True, max_length=5000, null=True)),
                ('password', models.CharField(blank=True, max_length=500, null=True)),
                ('meta_data', models.JSONField(blank=True, null=True)),
                ('expiry_date', models.DateTimeField(blank=True, null=True)),
                ('active', models.BooleanField(default=True)),
                ('type', models.CharField(blank=True, choices=[('PRODUCTION_CSID_ONBOARDING', 'Production CSID Onboarding'), ('PRODUCTION_CSID_RENEWING', 'Production CSID Renewing'), ('COMPLIANCE_CSID', 'Compliance CSID')], max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
            ],
            options={
                'db_table': 'takamol_einvoice.zatca_keys',
            },
        ),
        migrations.CreateModel(
            name='ZatcaLog',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('req', models.JSONField(blank=True, null=True)),
                ('res', models.JSONField(blank=True, null=True)),
                ('status_code', models.IntegerField(blank=True, null=True)),
                ('request_type', models.CharField(blank=True, choices=[('COMPLIANCE_CSID', 'Compliance CSID'), ('COMPLIANCE_CHECK', 'Compliance Check'), ('PRODUCTION_CSID_ONBOARDING', 'Production CSID Onboarding'), ('PRODUCTION_CSID_RENEWING', 'Production CSID Renewing'), ('REPORTING_INVOICE', 'Reporting Invoice')], max_length=50, null=True)),
                ('object_id', models.UUIDField()),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.contenttype')),
            ],
            options={
                'db_table': 'takamol_einvoice.zatca_logs',
            },
        ),
    ]
